/******************************************************************************
* Read a double column identified by its number from a catalogue file
* including allocation of memory
******************************************************************************/

#include <stdio.h>
#include <string.h>

#define L_WORD 2000


double *readadcoln(int icol, char *cat, int *n) {

  static int     nl;
  double         *par;
  static char    ocat[L_WORD]={""};
  FILE           *data_file;
  int            nlines(FILE *);
  FILE           *faskropen(char *, char *, int);
  void           errormsg(char *, ...),
                 readdcoln(int, char *, double *, int *);


  if (strcmp(ocat, cat)) {
    strcpy(ocat, cat);

    /* Count the number of lines in the catalogue */
    if ((data_file = faskropen("Data file?", cat, 3)) == NULL)
      errormsg("readadcoln(): Couldn't open %s!", cat);
    nl = nlines(data_file);
    fclose(data_file);
  }

  /* Allocate some memory */
  *n = nl;
  if ((par = (double *)calloc(*n, sizeof(double))) == NULL)
    errormsg("readadcoln(): Couldn't allocate memory!");

  /* Read the data */
  readdcoln(icol, cat, par, n);

  return par;
}
