/******************************************************************************
* Find a 'stand-alone' word in a string, i.e. the word has to be surrounded 
* by white spaces, and return the column number;
* Leading white spaces are ignored
******************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>


char *wdinstr(char *word, char *str, int *col) {

  char    *start, *p, *wd;
  char    *strpnws(char *), *strpws(char *);
  void    errormsg(char *, ...);


  /* Allocate some memory */
  if ((wd = (char *)calloc(strlen(word)+10, sizeof(char))) == NULL)
    errormsg("wdinstr(): Couldn't allocate memory!");

  /* Find the word */
  sprintf(wd, " %s ", word);
  if ((start = strstr(str, wd)) == NULL) {
    sprintf(wd, " %s\t", word);
    if ((start = strstr(str, wd)) == NULL) {
      sprintf(wd, "\t%s ", word);
      if ((start = strstr(str, wd)) == NULL) {
	sprintf(wd, "\t%s\t", word);
	if ((start = strstr(str, wd)) == NULL) {
	  sprintf(wd, "%s ", word);
	  if ((start = strstr(str, wd)) == NULL) {
	    sprintf(wd, "%s\t", word);
	    if ((start = strstr(str, wd)) == NULL) {
	      sprintf(wd, " %s\n", word);
	      if ((start = strstr(str, wd)) == NULL) {
		sprintf(wd, "\t%s\n", word);
		if ((start = strstr(str, wd)) == NULL) {
		  sprintf(wd, "%s\n", word);
		  if ((start = strstr(str, wd)) == NULL) {
		    free(wd);
		    return NULL;
		  }
		}
	      }
	    }
	  }
	}
      }
    }
  }

  /* Find the column */
  *col = 1;
  p = strpnws(str);
  while (p < start) {
    p = strpws(p);
    p = strpnws(p);
    (*col)++;
  }

  /* Clean up */
  free(wd);

  return p;
}
